import * as React from 'react';
import { History } from 'history';
export interface QueryParamContextValue {
    history: History;
}
export declare const QueryParamContext: React.Context<QueryParamContextValue>;
/**
 * Props for the Provider component, used to hook the active routing
 * system into our controls.
 */
interface Props {
    children: React.ReactNode;
    history: History;
}
/**
 * Context provider for query params to have access to the
 * active routing system, enabling updates to the URL.
 */
export declare function QueryParamProvider({ children, history }: Props): JSX.Element;
export default QueryParamProvider;
