"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var serialize_query_params_1 = require("serialize-query-params");
/**
 * Updates the URL to match the specified query changes.
 * If replaceIn or pushIn are used as the updateType, then parameters
 * not specified in queryReplacements are retained. If replace or push
 * are used, only the values in queryReplacements will be available.
 */
function updateUrlQuery(queryReplacements, history, updateType) {
    if (updateType === void 0) { updateType = 'replaceIn'; }
    var historyLocation = history.location;
    var inLocation = __assign(__assign({}, serialize_query_params_1.updateInLocation(queryReplacements, historyLocation)), { state: { useQueryParamsManaged: true } });
    var location = __assign(__assign({}, serialize_query_params_1.updateLocation(queryReplacements, historyLocation)), { state: { useQueryParamsManaged: true } });
    switch (updateType) {
        case 'replaceIn':
            history.replace(inLocation);
            break;
        case 'pushIn':
            history.push(inLocation);
            break;
        case 'replace':
            history.replace(location);
            break;
        case 'push':
            history.push(location);
            break;
        default:
    }
}
exports.updateUrlQuery = updateUrlQuery;
exports.default = updateUrlQuery;
